#!/bin/sh

# abort execution on any error
set -e

CROSSCOMPILE_MODULES="counter ltlc myheap nauty probhash random_permutations regexp user_signal fuzz"

libdir="../lib"
mkdir -p "$libdir"

if [ "$1" != "" ]
then
  bits=$1
else
  echo "\e[33mWarning: no argument provided, falling back to debian based architecture detection\e[0m"
  if [ $(dpkg --print-architecture) = "i386" ]
  then
    bits=32
  else
    bits=64
  fi
fi

# VC libs are added to the docker image
cp -v /libs/msvc*.dll $libdir

for module in $CROSSCOMPILE_MODULES; do
    make TARGET_BITS=$bits target_dir=../$libdir -C $module clean crosscompile
done
