#include <iostream>
#include <string>
#include <map>
#include <cstdlib>
#include <time.h>
#include <sicstus/sicstus.h>

using namespace std;


     multimap< SP_integer, SP_integer >   weight_id_map;
     SP_integer mycounter; // a simple counter; nothing to do with weight_id_map

extern "C" {

// two routines to manipulate mycounter
void mycounter_set(SP_integer counterval) {
  mycounter = counterval;
}

SP_integer mycounter_dec () {
  return --mycounter;
}




void myheap_reset() {
 //cout << "mymultimap_reset(); \n";
 weight_id_map.erase(weight_id_map.begin(),weight_id_map.end());
 // can probably be done faster
}

void myheap_initialize() {
 srand ( time(NULL) );
 myheap_reset();
}

void myheap_add_node_at_front(SP_integer nodeid){
   //cout << "mymultimap_add_node_at_front: " << nodeid  << endl;
    if(weight_id_map.empty()) {
		weight_id_map.insert( pair<SP_integer, SP_integer>( 1, nodeid) );
	 } else {
	    weight_id_map.insert( pair<SP_integer, SP_integer>( weight_id_map.begin()->first - 1, nodeid) );
	 }
}
void myheap_add_node_at_end(SP_integer nodeid){
   //cout << "mymultimap_add_node_at_end: " << nodeid  << endl;
 	if(weight_id_map.empty()) {
		weight_id_map.insert( pair<SP_integer, SP_integer>( 1, nodeid) );
	 } else {
		weight_id_map.insert( pair<SP_integer, SP_integer>( (--weight_id_map.end())->first + 1, nodeid) );
     }
}

void myheap_add_node_random(SP_integer nodeid){
 // cout << "mymultimap_add_node: " << nodeid << "," << nodeweight << endl;
 weight_id_map.insert( pair<SP_integer, SP_integer>( rand(), nodeid) );
}

void myheap_add_node(SP_integer nodeid, SP_integer nodeweight){
 // cout << "mymultimap_add_node: " << nodeid << "," << nodeweight << endl;
 weight_id_map.insert( pair<SP_integer, SP_integer>( nodeweight, nodeid) );
}

SP_integer myheap_size(){
  return weight_id_map.size();
}

SP_integer myheap_empty(){
  if(weight_id_map.empty())
     return 1;
  else
     return 0;
}

SP_integer myheap_top_weight(){
  return weight_id_map.begin()->first;
}
SP_integer myheap_top_id(){
  return weight_id_map.begin()->second;
}

SP_integer myheap_max_weight(){
  return (--weight_id_map.end())->first;
}

SP_integer myheap_pop(){
 if(weight_id_map.empty()) {
   // cout << "empty multimap in pop" << endl;
   return -1;
 } else {
	multimap< SP_integer, SP_integer >::iterator iter = weight_id_map.begin();
    SP_integer resid = iter->second;
    //SP_integer resweight = iter->first;
    //cout << "mymultimap_pop: " << resid << ":" << resweight << endl;
    //weight_id_map.erase(resid);
    weight_id_map.erase(iter);
 	return resid;
 }
}


SP_integer myheap_pop_max(){
 if(weight_id_map.empty()) {
   //cout << "empty multimap in pop_max" << endl;
   return -1;
 } else {
	multimap< SP_integer, SP_integer >::iterator iter = weight_id_map.end();
    SP_integer resid = (--iter)->second;
    //SP_integer resweight = iter->first;
    //cout << "mymultimap_pop_max: " << resid << ":" << resweight << endl;
    //weight_id_map.erase(resid);
    weight_id_map.erase(iter);
 	return resid;
 }
}

void myheap_portray(){
if(weight_id_map.empty()) {
  cout << "empty multimap" << endl;
} else {
	cout << "< ";
	multimap< SP_integer, SP_integer >::iterator iter = weight_id_map.begin();
	while (iter != weight_id_map.end()) {
		cout << "(" << iter->first << "," << iter->second << ") "	;
		iter++;
	}
	cout << " >" << endl;
}
}
}
