#ifndef MSTATS_H_INCLUDED
#define MSTATS_H_INCLUDED

#include <zmq.h>
#include <czmq.h>

typedef struct proxy_digests {
    int header;
    union {
        int full;
        int empty;
    };
    zmsg_t *need_msg;
    int acks_received;
    int acks_expected;
} pDigest;

typedef struct mstats {
    pDigest *pdigests;
    size_t len;
} mStats;

void print_mstats(mStats const * const digests, int fd_logfile);

/* updates a new digest-message into the buffer of digests. 
 * new_digest was sent with given header. 
 * function takes ownership of the message. */
void update_queue_digests(mStats * const digests, const int header, zmsg_t *new_digest, int fd_logfile);

/* returns the possible amount of global transfers */
int m_can_balance(mStats const * const digests);

int m_do_balance(mStats const * const digests,
                 int seq_num,
                 zsock_t * const pub,
                 char const * const idmap[],
                 int fd_logfile);

int stats_can_terminate(mStats const * const stats);

void teardown_mstats(mStats * const digests);
#endif
