#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <stdio.h>

#include <zmq.h>
#include <czmq.h>

#include "../common/msg_headers.h"
#include "wid.h"

struct id_response worker_request_id(char const * const endpoint) {
    zsock_t *zocket = zsock_new_req(endpoint);

    int rc = zsock_send(zocket, "i", W_ID_REQUEST);
    assert(rc == 0);

    struct id_response res;
    rc = zsock_recv(zocket, "ic", &(res.id), &(res.model));
    assert(rc == 0);

    zsock_destroy(&zocket);
    return res;
}


struct id_response query_proxy_for_id(const int proxy_number) {
    char *endpoint_req;
    int rc = asprintf(&endpoint_req,"ipc:///tmp/zmq-proxy-%d-id", proxy_number);
    assert(rc != -1);

    struct id_response rep = worker_request_id(endpoint_req);
    free(endpoint_req);
    return rep;
}
