% (c) 2009-2020 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)
:- module(basic_unit_tests,[]).

% unit tests which are put into a separate module to avoid
% cycles in the basic modules (preferences, tools, ...)

:- use_module(self_check).
:- use_module(preferences).

:- assert_must_succeed(print_preferences).
:- assert_must_succeed(get_non_default_preferences(_)).

:- assert_must_succeed( \+((eclipse_preference(_EP,P), \+preference_default_value(P,_Val)))).

:- assert_must_succeed( \+((preference_description(P,_D),\+preference_default_value(P,_Val)))).
:- assert_must_succeed( \+((preference_default_value(P,_D), \+preference_description(P,_Val)))).



:- assert_must_succeed( \+((preference_val_type(P,_D),\+preference_default_value(P,_Val)))).
:- assert_must_succeed( \+((preference_default_value(P,_D), \+preference_val_type(P,_Val)))).


:- assert_must_succeed( \+((preference_category(P,_D),\+preference_default_value(P,_Val)))).
:- assert_must_succeed( \+((preference_default_value(P,_D), \+preference_category(P,_Val)))).


:- assert_must_succeed( \+((preferences:obsolete_preference(P),preference_default_value(P,_Val)))).
