% (c) 2015-2020 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(ce_replay,[replay_counter_example/1]).

:- use_module(probsrc(module_information)).
:- module_info(group,symbolic_model_checker).
:- module_info(description,'Replay symbolically generated traces.').

:- use_module(probsrc(state_space),[state_space_reset/0]).

:- use_module(symbolic_model_checker(predicate_handling), [create_state_predicate/2,
                                                           create_constants_state_predicate/2,
                                                           deprime_state/2]).

:- use_module(probsrc(b_trace_checking),[find_successor_state/4]).
replay_counter_example(Sol) :-
    state_space_reset,replay_aux(Sol,_).
replay_aux(Sol,CurId) :-
    create_constants_state_predicate(Sol,ConstantsStatePred), !,
    find_successor_state(CurId,ConstantsStatePred,SuccID,0),
    replay_aux2(Sol,SuccID,1).
replay_aux(Sol,CurId) :-
    replay_aux2(Sol,CurId,1).
replay_aux2([],_,_).
replay_aux2(Sol,CurId,LineNr) :-
    create_state_predicate(Sol,StatePred),
    % print(find(CurId,LineNr,Sol)),nl, translate:print_bexpr(StatePred),nl,
    find_successor_state(CurId,StatePred,SuccID,LineNr),
    deprime_state(Sol,DPSol),
    L1 is LineNr+1,
    replay_aux2(DPSol,SuccID,L1).
