
check_interval_in_avl also works for any CS:

subset_of_explicit_set(Closure,CS,Code,WF) :- nonvar(CS), is_custom_explicit_set(CS),
   is_interval_closure_or_integerset(Closure,Low,Up),!,
   Code=custom_explicit_sets:check_interval_in_avl(Low,Up,CS,WF).
check_interval_in_avl(Low,Up,A,WF) :-
    Low \== minus_inf,
    Up \== inf,
    b_interpreter_check:check_arithmetic_operator('<=',Low,Up,LeqRes),
    print(check_interval_in_avl(LeqRes,Low,Up,A)),nl,
    (var(LeqRes) -> get_binary_choice_wait_flag_exp_backoff(16,check_interval_in_avl,WF,WF2) ; true),
    check_interval_in_avl_aux(LeqRes,Low,Up,A,WF2).

:- block check_interval_in_avl_aux(-,?,?,?,-).
check_interval_in_avl_aux(P,Low,Up,CS,WF2) :- print(check_interval_in_avl_aux(P,Low,Up,CS,WF2)),nl,fail.
check_interval_in_avl_aux(pred_true,Low,Up,CS,_WF2) :- print(not_empty),nl,
    element_of_custom_set_wf(int(Low),CS,WF),
    element_of_custom_set_wf(int(Up),CS,WF),
    interval_in_avl_block(Low,Up,CS,WF).
check_interval_in_avl_aux(pred_false,_Low,_Up,_CS,_WF2) :- print(empty),nl. % Interval is empty; but infinitely many solutions for Low and Up

:- block interval_in_avl_block(-,?,?,?), interval_in_avl_block(?,-,?,?).
interval_in_avl_block(Low,Up,CS,WF) :- %print(interval_in_avl_block(Low,Up,CS)),nl,
    Low1 is Low+1, interval_in_avl_loop(Low1,Up,CS,WF).
interval_in_avl_loop(Low,Up,_CS,_WF) :- Low>=Up,!. % Lower bound and upper bound already checked
interval_in_avl_loop(Low,Up,CS,WF) :- %print(chck(Low,Up,CS)),nl,
    element_of_custom_set_wf(int(Low),CS,WF), L1 is Low+1,
    interval_in_avl_loop(L1,Up,CS,WF).

check_interval_in_avl(Low,Up,A,WF) :-
    Low \== minus_inf,
    Up \== inf,
    b_interpreter_check:check_arithmetic_operator('<=',Low,Up,LeqRes),
    %print(check_interval_in_avl(LeqRes,Low,Up,A)),nl,
    (var(LeqRes) -> get_binary_choice_wait_flag_exp_backoff(16,check_interval_in_avl,WF,WF2) ; true),
    check_interval_in_avl_aux(LeqRes,Low,Up,A,WF2).

:- block check_interval_in_avl_aux(-,?,?,?,-).
%check_interval_in_avl_aux(P,Low,Up,A,WF2) :- print(check_interval_in_avl_aux(P,Low,Up,A,WF2)),nl,fail.
check_interval_in_avl_aux(pred_true,Low,Up,A,_WF2) :- %print(not_empty),nl,
    element_of_avl_set_wf(A,int(Low),WF),
    element_of_avl_set_wf(A,int(Up),WF),
    interval_in_avl_block(Low,Up,A).
check_interval_in_avl_aux(pred_false,_Low,_Up,_A,_WF2) :- print(empty),nl. % Interval is empty; but infinitely many solutions for Low and Up

:- block interval_in_avl_block(-,?,?), interval_in_avl_block(?,-,?).
interval_in_avl_block(Low,Up,A) :- %print(interval_in_avl_block(Low,Up,A)),nl,
    Low1 is Low+1, interval_in_avl_loop(Low1,Up,A).
interval_in_avl_loop(Low,Up,_A) :- Low>=Up,!. % Lower bound and upper bound already checked
interval_in_avl_loop(Low,Up,A) :- %print(chck(Low,Up,A)),nl,
    safe_avl_member(int(Low),A), L1 is Low+1, interval_in_avl_loop(L1,Up,A).


% closure (reflexive) now done in ast_cleanup:

/* reflexive & transitive closure */
closure0_for_explicit_set(avl_set(A),Res) :-
   avl_domain(A,List),
   closure1_for_explicit_set(avl_set(A),Res1),
   (Res1==[] -> A2=empty ; Res1 = avl_set(A2)),
   add_id_pairs(List,none,A2,A3),
   construct_avl_set(A3,S3),
   kernel_objects:equal_object(Res,S3,closure0_for_explicit_set).

add_id_pairs([],_,R,R).
add_id_pairs([Key|T],LastX,AVL,Res) :-
    (Key = (X,Y) -> true ; add_error_and_fail(add_id_pairs,'Not a relation element: ',Key)),
    (X=Y -> AVL2=AVL /* must already be in closure1 result */
          ; (LastX==X -> AVL1=AVL ; avl_store((X,X),AVL,true,AVL1)), % already added
            avl_store((Y,Y),AVL1,true,AVL2)
    ),
    add_id_pairs(T,X,AVL2,Res).

/* FROM bsets_clp.pl: */

/* The transitive & reflexive closure of a relation */

:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4))],X),
                        kernel_objects:equal_object(X,[(int(1),int(1)),(int(1),int(4)),(int(4),int(4))]))).
:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4)),(int(4),int(2))],X),
                        kernel_objects:equal_object(X,[(int(1),int(1)),(int(2),int(2)),(int(4),int(4)),(int(1),int(4)),(int(4),int(2)),
                                             (int(1),int(2))]))).
:- assert_must_succeed((bsets_clp:relational_reflexive_closure([(int(1),int(4)),(int(4),int(2)),(int(2),int(3))],X),
kernel_objects:equal_object(X,[(int(1),int(1)),(int(2),int(2)),(int(3),int(3)),(int(4),int(4)),
                                      (int(1),int(4)),(int(4),int(2)),(int(2),int(3)),
                                             (int(4),int(3)),(int(1),int(2)),(int(1),int(3))]))).

:- block relational_reflexive_closure(-,?).
relational_reflexive_closure(Relation,Result) :-
    try_expand_and_convert_to_avl_with_check(Relation,ARelation,relational_reflexive_closure),
    relational_reflexive_closure2(ARelation,Result).
:- block relational_reflexive_closure2(-,?).
relational_reflexive_closure2(ARelation,Result) :- % print_term_summary(closure(ARelation,Result)),
    (closure0_for_explicit_set(ARelation,Res)
      -> kernel_objects:equal_object(Res,Result)
      ; (expand_custom_set_to_list(ARelation,ERelation,_,relational_reflexive_closure2),
         is_full_relation(ERelation,WaitVar),
         compute_trans_closure(ERelation,Result1,WaitVar),
        % print(adding_id(ERelation,Result1)),nl,
         rel_iterate0(ERelation,Result1,Result)
        %, print(done(Result)),nl
        )
    ).

% -------------------
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(12)),[(int(11),int(3))],pred_false,WF),WF)).
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(11)),[(int(11),int(3))],pred_true,WF),WF)).
:- assert_must_succeed(exhaustive_kernel_check_wfdet(bsets_clp:in_closure0_membership_test_wf((int(11),int(3)),[(int(11),int(3))],pred_true,WF),WF)).

:- block in_closure0_membership_test_wf(?,-,?,?).
in_closure0_membership_test_wf((A,B),CSRelation,MemRes,WF) :-
    equality_objects_wf(A,B,MemRes1,WF),
    (MemRes1==pred_true -> MemRes=pred_true
      ; in_closure1_membership_test_wf((A,B),CSRelation,MemRes2,WF),
        b_interpreter_check:disjoin(MemRes1,MemRes2,MemRes,priority(1),priority(1000),WF)
    ).



/* not used at the moment:
% compute the worst case: max(card(rel[{x}]) for x:dom(rel))
% this can be done using a simple traversal
avl_out_degree(AS,Degree) :- avl_out_degree_aux(AS,'$none',0,0,_,_,Degree).
avl_out_degree_aux(empty,K,N,R,K,N,R).
avl_out_degree_aux(node((KeyFrom,_KeyTo),_true,_,L,R),CurKey,CurNr,DegreeSoFar,OutKey,OutNr,OutRes) :-
   avl_out_degree_aux(L,CurKey,CurNr,DegreeSoFar, OutKey1,OutNr1,OutRes1),
   (OutKey1 = KeyFrom -> NextNr is OutNr1+1, DegreeSoFar2 = OutRes1
     ; NextNr is 1,
      (OutNr1 > OutRes1 -> DegreeSoFar2 = OutNr1 ; DegreeSoFar2 = OutRes1)
    ),
   avl_out_degree_aux(R,KeyFrom,NextNr,DegreeSoFar2, OutKey,OutNr,OutRes).
*/



% compute size of range   ; currently not used
%avl_range_size_and_propagate_element_info(A,XDomElement,YRangeElement,Size) :-
%   avl_domain(A,EC), % -> expand_custom_set(avl_set(A),EC),
%   range(EC,R), sort(R,SortedList), %normalised_list_to_avl(R,SortedList,Res),
%   length(SortedList,Size).

/*
  causes problem for:
  probsli examples/EventBPrologPackages/SET_Game/SET_GAM_Sym_NoSet20_mch.eventb -mc 1000 -p SYMMETRY_MODE hash -p TIME_OUT 7000 -p CLPFD TRUE -df -goal n=18 -p MAX_OPERATIONS 20 -strict -expcterr goal_found -p CLPFD TRUE

   print(avl_range_size(Size,YRangeElement,SortedList)),nl,
   % now propagate the information that YRangeElement must appear in SortedList
   propagate_list_element_information(SortedList,Size,XDomElement,YRangeElement).

propagate_list_element_information([H-_|T],_,_,Y) :- T==[],!, equal_object(Y,H).
propagate_list_element_information([int(H)-_|T],_,_,Y) :- preferences:preference(use_clpfd_solver,true),!,
    project_avl_domain_ordlist_on_fd(T,FDList), Y = int(YY),
    clpfd_interface:clpfd_inlist(YY,[H|FDList]).
propagate_list_element_information([fd(H,Type)-_|T],Size,_,Y) :- preferences:preference(use_clpfd_solver,true),!,
   b_global_sets:b_fd_card(Type,Card),
   (Size >= Card -> true  % range is the full type
     ; project_avl_domain_ordlist_on_fd(T,FDList), Y = fd(YY,Type),
      clpfd_interface:clpfd_inlist(YY,[H|FDList])).
propagate_list_element_information(_List,_,_X,_Y). % :- when(ground(Y),(ground(X) -> true ; member(YY-_,List),equal_object(Y,YY))). % enable this again when we use WF2 below rather than GroundY

project_avl_domain_ordlist_on_fd([],[]).
project_avl_domain_ordlist_on_fd([H-_|T],[PH|PT]) :-
    project_avl_domain(H,PH), project_avl_domain_ordlist_on_fd(T,PT).

*/

% not yet finished:
%apply_to_explicit_set(closure(Parameters,PT,Cond),X,Y,WF) :-
%    closure_member(X,Parameters,PT,Cond,WF).


/*
apply_check_tuple_ground(X,Y,A,Span,WF) :-
     convert_to_avl_inside_set(X,AX),!, % we can do optimized lookup + checking in one go
     avl_apply(AX,A,XY,Span,WF), kernel_objects:equal_object(XY,Y).
apply_check_tuple_ground(X,Y,A,_Span,_WF) :- preferences:preference(find_abort_values,false), !, safe_avl_member_default((X,Y),A).
apply_check_tuple_ground(X,Y,A,Span,WF) :- !,
    if(safe_avl_member_default((X,XY),A),  % does not detect abort errors if X unbound
        kernel_objects:equal_object(XY,Y),
        add_wd_error_span('function applied outside of domain (#4): ','@fun'(X,avl_set(A)),Span,WF)).
*/

/* TO DO: complete
in_domain_of_explicit_set(X,avl_set(A),WF) :-
   ground(X),!, in_domain2(X,A).
in_domain_of_explicit_set(X,avl_set(A),WF) :-
   avl_size(A,Size),
   get_wait_flag(Size,in_domain_of_explicit_set(X),WF,WF1),
    when((ground(X); nonvar(WF1)), in_domain2(X,A) ).
in_domain_of_explicit_set(X,closure(P,T,B),WF) :-   to avoid expanding closure *

in_domain2(X,AVL) :- ground(X),!, ..convert_to_avl...
   avl_fetch_pair_0(X,A,'=',_).
 ... -> write avl_domain_member
 */


union_of_avl(A1,A2,ARes) :- MaxDiff=4,
   avl_tools:avl_height_compare_up_to(A1,A2,MaxDiff,SmHeight,Res),
   (SmHeight =< 2 -> union_of_avl2(A1,A2,ARes)
    ; Res =eq -> union_of_avl2(A1,A2,ARes)
    ; Res=lt -> union_of_avl1(A2,A1,ARes)
    ; union_of_avl1(A1,A2,ARes)).
union_of_avl1(A1,A2,ARes) :- %Sz2>2, Sz1 =< Sz2+3, % difference not too big; Sz2 at least a certain size
     %!,
       print(union(Sz1,Sz2)),nl,
     avl_to_list(A2,List2), % get all members
     avl_to_list(A1,List1),
     ord_union(List1,List2,L12),
     ord_list_to_avl(L12,ARes).
union_of_avl2(A1,A2,ARes) :-  % this version is better when A2 is small compared to A1
     avl_domain(A2,List2), % get all members
     add_to_avl(List2,A1,ARes).


%compute the sum of the range elements; was used for SIGMA
%sum_of_range_custom_explicit_set(avl_set(A),R) :- %print(sum_avl(A)),nl, %
%  avl_domain(A,Dom), simple_range_sum_list(Dom,0,Sum), %print(avl_sum(Sum)),nl,
%  R=int(Sum).
%
%simple_range_sum_list([],A,A).
%simple_range_sum_list([(_,int(H))|T],Acc,R) :- NA is Acc+H, simple_range_sum_list(T,NA,R).
%
%compute the product of the range elements; was used for PI
%mul_of_range_custom_explicit_set(avl_set(A),R) :- %print(sum_avl(A)),nl, %
%  avl_domain(A,Dom),
%  simple_range_mul_list(Dom,1,Sum), %print(avl_mul(Sum)),nl,
%  R=int(Sum).
%
%simple_range_mul_list([],A,A).
%simple_range_mul_list([(_,int(H))|T],Acc,R) :- NA is Acc*H, simple_range_mul_list(T,NA,R).
